﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web.Http;
using System.Web.Mvc;
using CustomEditorProblem.Models;

namespace CustomEditorProblem.Controllers
{
    public class HomeController : Controller
    {
        DataEntities e = new DataEntities();

        public ActionResult Index()
        {
            Session.Add("l", new List<StaffRoleGridItem>());
            return View();
        }

        public JsonResult _List()
        {
            List<StaffRoleGridItem> l = (List<StaffRoleGridItem>)Session["l"];
            return Json(new { Data = l.AsQueryable() }, JsonRequestBehavior.AllowGet);
        }

        public JsonResult _Add(FormCollection fc)
        {
            List<StaffRoleGridItem> l = (List<StaffRoleGridItem>)Session["l"];

            int role = 0;
            int user = 0;

            int id = 0;

            if (int.TryParse(fc["StaffRole"], out role) &&
                int.TryParse(fc["StaffUser"], out user))
            {
                var _role = e.Roles.Where(x => x.Id == role).FirstOrDefault();
                var _user = e.Users.Where(x => x.Id == user).FirstOrDefault();

                StaffRoleGridItem o = new StaffRoleGridItem
                {
                    Id = l.Count + 1,
                    StaffRole = new StaffRoleGridItem.StaffRoleEnum
                    {
                        Id = _role.Id,
                        Description = _role.Value
                    },
                    StaffUser = new StaffRoleGridItem.StaffRoleUser
                    {
                        Id = _user.Id,
                        Name = _user.Value
                    }
                };

                id = o.Id;
                l.Add(o);
                Session.Add("l", l);
            }

            return Json(new { Data = l.Where(x => x.Id == id).FirstOrDefault() }, JsonRequestBehavior.AllowGet);

            
        }
    }
}
